from gpioserver.gpioclient import GPIOClient

class LED:
    def __init__(self, cli, ind):
        self.cli = cli
        self.ind = ind

    def on(self):
        self.cli.led(self.ind, 1)

    def blink(self, ton, toff):
        self.cli.blink(self.ind, 1, ton, toff)

    def off(self):
        self.cli.led(self.ind, 0)

print('ledscli create cli')
cli = GPIOClient({})
        
ledr = LED(cli, 0)
ledg = LED(cli, 1)
ledb = LED(cli, 2)

leds = [ledr, ledg, ledb]

def redlight():
    ledr.on()

def greenlight():
    ledg.on()

def bluelight():
    ledb.on()

def lighton(which):
    aleds = [leds[k] for k in range(len(leds)) if which[k]]
    [x.on() for x in aleds]

def lightset(which):
    cli.setstate(which)

def blinkset(which):
    cli.setstate(which, [0.7, 0.3])

def alloff():
    [x.off() for x in leds]

if __name__ == "__main__":
    import time

    lightset([0, 0, 0])

    tests = [redlight, greenlight, bluelight,
             lambda: lightset([1, 1, 0]),
             lambda: lightset([1, 0, 1]),
             lambda: lightset([0, 1, 1]),
             ]

    for test in tests:
        print(test)
        test()
        print(ledr, ledg, ledb)
        time.sleep(1)
