class QueueEmpty(BaseException):
    pass
class QueueFull(BaseException):
    pass

class Queue:

  def __init__(self, size):
    size = int(size)
    self.queue = [None]*size
    self.front = 0
    self.rear = 0
    self.size = size
    self.available = size
 
  def put(self, item):
    if self.available == 0:
      raise(QueueFull())
    else:
      self.queue[self.front] = item
      self.front = (self.front + 1) % self.size
      self.available -= 1
 
  def get(self):
    if self.empty():
      raise(QueueEmpty())
    else:
      item = self.queue[self.rear]
      self.queue[self.rear] = None
      self.rear = (self.rear + 1) % self.size
      self.available += 1
      return item
 
  def peek(self):
    return self.queue[self.rear]
 
  def __str__(self):
    return 'Q %s/%d full' % (self.qsize(), self.size)

  def print_queue(self):
    print(self.queue)

  def qsize(self):
    return self.size - self.available

  def empty(self):
    return self.size == self.available
